Rapture = LibStub("AceAddon-3.0"):NewAddon("Rapture", "AceConsole-3.0", "AceEvent-3.0")
RaptureGUI = LibStub("AceGUI-3.0")
RaptureBAR = LibStub("LibCandyBar-3.0"):New("Interface\\AddOns\\Rapture\\media\\statusbar.tga", 200, 18)

local defaults = {
    profile = {
		scale = 1.0,
		xpos = 0,
		ypos = 0,
    },
}

local options = {
  type = "group",
  childGroups = "tab",
  args = {
		info = {
		  name = "Info",
		  desc = "Shows info about the addon",
		  type = 'execute',
		  func = function()
			Rapture:Print("This addon shows a neat bar too see how long cooldown is left on your rapture ability.")
		  end,
		},
		test = {
		  name = "Test",
		  desc = "Test rapture cooldown bar",
		  type = 'execute',
		  func = function()
--		  	RaptureBAR:SetTexture(Rapture.db.profile.texture)
--			RaptureBAR:SetWidth(Rapture.db.profile.width)
--			RaptureBAR:SetHeight(Rapture.db.profile.height)
			RaptureBAR:SetScale(Rapture.db.profile.scale)
			RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
			RaptureBAR:SetColor(0, 0.5, 1, 1)
			RaptureBAR:SetLabel("Rapture cooldown")
			RaptureBAR:SetDuration(12)
			RaptureBAR:Start()
		  end,
		},
	bar = {
      type = "group",
      name = "Bar options",
      args = {
	    barposdesc = {
		  order = 1,
          type = "description",
          name = "Bar positioning\n",
          cmdHidden = true
        },
		xpos = {
		  order = 2,
          name = "X",
          desc = "Change horizontal position",
          type = 'range',
          min = -500,
          max = 500,
          step = 1,
          get = function(info) return Rapture.db.profile.xpos end,
          set = function(info, x) 
		  Rapture.db.profile.xpos = x
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetColor(0, 0.5, 1, 1)
		  RaptureBAR:SetLabel("TEST BAR")
		  RaptureBAR:SetDuration(20)
		  RaptureBAR:Start()
		  end,
		},
		ypos = {
		  order = 3,
          name = "Y",
          desc = "Change veritcal position",
          type = 'range',
          min = -500,
          max = 500,
          step = 1,
          get = function(info) return Rapture.db.profile.ypos end,
          set = function(info, y) 
		  Rapture.db.profile.ypos = y
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetColor(0, 0.5, 1, 1)
		  RaptureBAR:SetLabel("TEST BAR")
		  RaptureBAR:SetDuration(20)
		  RaptureBAR:Start()
		  end,
		  },
		scaledesc = {
		  order = 4,
          type = "description",
          name = "\n\nScale\n",
          cmdHidden = true
        },
		scale = {
		  order = 5,
          name = "Scale",
          desc = "Set scale",
          type = 'range',
          min = 0.5,
          max = 2,
          step = 0.1,
          get = function(info) return Rapture.db.profile.scale end,
          set = function(info, s) 
		  Rapture.db.profile.scale = s
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetColor(0, 0.5, 1, 1)
		  RaptureBAR:SetLabel("TEST BAR")
		  RaptureBAR:SetDuration(20)
		  RaptureBAR:Start()
		  end,
		},
	  },
	},
  },
}

function Rapture:OnInitialize()
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Rapture", "Rapture")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Rapture", options, {"rapture", "rap", "Rapture", "Rap"})
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("Rapture", options)
    self.db = LibStub("AceDB-3.0"):New("RaptureDB", defaults, "Default")
end

function Rapture:OnEnable()
	self:Print("Rapture Loaded")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end



function Rapture:SPELL_ENERGIZE(timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, auraType, amount)
	local player_name = UnitName("player")
	if spellName == "Rapture" and destName == player_name and sourceName == player_name and spellId == 47755 then
		RaptureBAR:SetScale(Rapture.db.profile.scale)
		RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		RaptureBAR:SetColor(0, 0.5, 1, 1)
		RaptureBAR:SetLabel("Rapture cooldown")
		RaptureBAR:SetDuration(12)
		RaptureBAR:Start()
	end
end

function Rapture:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, amount, spellID, ...)
	local func = self[event]
	if (func) then
		func(self, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, amount, spellID, ...)
	end
end